/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: DevDetailURI.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//

#include "spdm/win32/DevDetailURI.h"
#include "common/Log.h"

DevDetailURI::DevDetailURI(ManagementNode* node) {

    LOG.debug(TEXT("in DevDetailURI"));    
    readFromDM(node);       
}


wchar_t* DevDetailURI::getMaxDepth() {
    return maxDepth;
}

void DevDetailURI::setMaxDepth(wchar_t* p) {
    wcsncpy(maxDepth, p, DIM_MAXDEPTH);
    maxDepth[DIM_MAXDEPTH -1] = 0;
    
}

wchar_t* DevDetailURI::getMaxTotLen() {
    return maxTotLen;
}

void DevDetailURI::setMaxTotLen(wchar_t* p) {
    wcsncpy(maxTotLen, p, DIM_MAXTOTLEN);
    maxTotLen[DIM_MAXTOTLEN -1] = 0;
    
}

wchar_t* DevDetailURI::getMaxSegLen() {
    return maxSegLen;
}

void DevDetailURI::setMaxSegLen(wchar_t* p) {
    wcsncpy(maxSegLen, p, DIM_MAXSEGLEN);
    maxSegLen[DIM_MAXSEGLEN -1] = 0;
    
}



BOOL DevDetailURI::readFromDM(ManagementNode* node) {
    
    BOOL ret = FALSE;

    if (node == NULL) {
        lastErrorCode = ERR_INVALID_CONTEXT;
        wsprintf(lastErrorMsg, TEXT("DevDetailURI node configuration NULL"));
        LOG.error(lastErrorMsg);
        goto finally;
    }
    wchar_t buf[INT_VALUESIZE]; // big enough for everything

    node->getPropertyValue(PROPERTY_MAXDEPTH,   buf, INT_VALUESIZE, FALSE );
    setMaxDepth(buf);

    node->getPropertyValue(PROPERTY_MAXTOTLEN,  buf, INT_VALUESIZE, FALSE );
    setMaxTotLen(buf);

    node->getPropertyValue(PROPERTY_MAXSEGLEN,  buf, INT_VALUESIZE, FALSE );
    setMaxSegLen(buf);

   
    if (lastErrorCode != 0) {
        wsprintf(lastErrorMsg, TEXT("DevDetailURI configuration not found"));
        LOG.error(lastErrorMsg);
        goto finally;
    }

    ret = TRUE;
    
finally:
    return FALSE;

}

