/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: DevInfo.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//

#include "spdm/win32/DevInfo.h"
#include "common/Log.h"

DevInfo::DevInfo(ManagementNode* node) {

    LOG.debug(TEXT("in devInfo"));    
    readFromDM(node);       
}


wchar_t* DevInfo::getDevId() {
    return devId;
}

void DevInfo::setDevId(wchar_t* p) {
    wcsncpy(devId, p, DIM_DEVID);
    devId[DIM_DEVID -1] = 0;
    
}

wchar_t* DevInfo::getMan() {
    return man;
}

void DevInfo::setMan(wchar_t* p) {
    wcsncpy(man, p, DIM_MAN);
    man[DIM_MAN -1] = 0;
    
}

wchar_t* DevInfo::getMod() {
    return mod;
}

void DevInfo::setMod(wchar_t* p) {
    wcsncpy(mod, p, DIM_MOD);
    mod[DIM_MOD -1] = 0;
    
}

wchar_t* DevInfo::getDmv() {
    return dmv;
}

void DevInfo::setDmv(wchar_t* p) {
    wcsncpy(dmv, p, DIM_DMV);
    dmv[DIM_MOD -1] = 0;
    
}

wchar_t* DevInfo::getLang() {
    return lang;
}

void DevInfo::setLang(wchar_t* p) {
    wcsncpy(lang, p, DIM_LANG);
    lang[DIM_LANG -1] = 0;
    
}

BOOL DevInfo::readFromDM(ManagementNode* node) {
    
    BOOL ret = FALSE;

    if (node == NULL) {
        lastErrorCode = ERR_INVALID_CONTEXT;
        wsprintf(lastErrorMsg, TEXT("DevInfo node configuration NULL"));
        LOG.error(lastErrorMsg);
        goto finally;
    }
    wchar_t buf[INT_VALUESIZE]; // big enough for everything

    node->getPropertyValue(PROPERTY_DEVID, buf, INT_VALUESIZE, FALSE );
    setDevId(buf);

    node->getPropertyValue(PROPERTY_MAN,   buf, INT_VALUESIZE, FALSE );
    setMan(buf);

    node->getPropertyValue(PROPERTY_MOD,   buf, INT_VALUESIZE, FALSE );
    setMod(buf);

    node->getPropertyValue(PROPERTY_DMV,   buf, INT_VALUESIZE, FALSE );
    setDmv(buf);

    node->getPropertyValue(PROPERTY_LANG,  buf, INT_VALUESIZE, FALSE );
    setLang(buf);
    
    if (lastErrorCode != 0) {
        wsprintf(lastErrorMsg, TEXT("DevInfo configuration not found"));
        LOG.error(lastErrorMsg);
        goto finally;
    }

    ret = TRUE;
    
finally:
    return FALSE;

}

