/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_DM_DEVINFO
    #define INCL_DM_DEVINFO

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"

    #define PROPERTY_DEVID    TEXT("DevId")
    #define PROPERTY_MAN      TEXT("Man"  )
    #define PROPERTY_MOD      TEXT("Mod"  )
    #define PROPERTY_DMV      TEXT("Dmv"  )
    #define PROPERTY_LANG     TEXT("Lang" )
    
    #define INT_VALUESIZE         512
    
    class __declspec(dllexport) DevInfo {

    private:

        wchar_t devId   [DIM_DEVID];
        wchar_t man     [DIM_MAN  ];
        wchar_t mod     [DIM_MOD  ];
        wchar_t dmv     [DIM_DMV  ];
        wchar_t lang    [DIM_LANG ];
        

    public:
        DevInfo();
        DevInfo(ManagementNode* node);

        wchar_t* getDevId();
        void setDevId(wchar_t* devId);

        wchar_t* getMan();
        void setMan(wchar_t* man);

        wchar_t* getMod();
        void setMod(wchar_t* mod);

        wchar_t* getDmv();
        void setDmv(wchar_t* dmv);

        wchar_t* getLang();
        void setLang(wchar_t* lang);

     
        /*
         * Reads the configuration from the device manager
         */
        BOOL readFromDM(ManagementNode* node);

        /*
         * Stores the changed information into the device manager.
         * It returns TRUE if the operation was successfull, FALSE otherwise.
         *
         * NOTE: this methods must be mainly developed. For now it stores the sources
         *       last timestamp only. Is TBD to trace which fields are changed and
         *       persists them in the DM as well.
         */
        //BOOL saveToDM();

    };
#endif