/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_DM_SYNCMLDMCONFIG
    #define INCL_DM_SYNCMLDMCONFIG

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"
    #include "spdm/win32/SyncMLDMCon.h"
    #include "spdm/win32/SyncMLDMAcc.h"
    
    #define  DM_ROOT_CONTEXT          TEXT("Funambol/DM"   )
    #define  DM_DEVINFO_CONTEXT       TEXT("DevInfo"       )
    #define  DM_DEVDETAIL_CONTEXT     TEXT("DevDetail"     )
    #define  DM_DEVDETAILURI_CONTEXT  TEXT("DevDetail/URI" )

    #define  DM_CON_CONTEXT     TEXT("SyncML/Con/Dummy/NAP")
    #define  DM_ACC_CONTEXT     TEXT("SyncML/DMAcc"        )
    
    
    class __declspec(dllexport) SyncMLDMConfig {

    private:

       

    public:
        
        
        SyncMLDMConfig();
        SyncMLDMConfig(ManagementNode* node, wchar_t* accNodeName);
        ~SyncMLDMConfig();

        SyncMLDMAcc* syncMLDMAcc;
        SyncMLDMCon* syncMLDMCon;
        
        /*
        * Store the name of the Acc node passed by 
        */
        wchar_t* nameDMAcc; 
        /*
         * Reads the configuration from the device manager
         */
        //BOOL readFromDM(ManagementNode* node);

        /*
         * Stores the changed information into the device manager.
         * It returns TRUE if the operation was successfull, FALSE otherwise.
         *
         * NOTE: this methods must be mainly developed. For now it stores the sources
         *       last timestamp only. Is TBD to trace which fields are changed and
         *       persists them in the DM as well.
         */
        BOOL saveToDM();

        

        

    };
#endif